ILOSC_SLOW	equ	128
ILOSC_NOP	equ	128
ILOSC_TESTOW	equ	4


	clr.w	-(sp)				; ---------
	move.w	#$20,-(sp)			; SUPER
	trap	#1					;
	addq.l	#4,sp				;

	lea		old_sr(pc),A0
	move.w	sr,(A0)
	move.w	#$2700,sr			; Interrupts STOP


;BLITTER INIT
	lea	$ffff8a20.w,a0			; ---------

	move.l	#$00000,(a0)+		; source X / Y increment
	lea		$ffff8922.w,A5		;
	move.l	A5,(a0)+			; source address
	move.l	#-1,(a0)+			; mask 1 /2
	move.w	#-1,(a0)+			; mask 3
	move.l	#$00002,(a0)+		; destination X / Y increment
	lea		bufor3(pc),A1		;
	move.l	A1,(a0)+			; destination address
	move.w	#$0001,(a0)+		; count X surface
	move.w	#ILOSC_SLOW,(a0)+	; count Y surface
	move.w	#$0203,(a0)+		; HOP / LOP
	move.b	#$00,(a0)			; BUSY / HOG / SMUDGE / LINE NUMBER
	move.b	#$00,1(a0)			; FXSR / NFSR / SKEW

	move.b	#$c0,D2				; normalny start

	move.l	A0,A4				; BUSY / HOG / SMUDGE / LINE NUMBER - start blitter


;REG INIT
	lea		bufor(pc),A0
	lea		bufor1(pc),A1
	move.l	A0,D0
	add.l	D0,(A1)
	lea		bufor2(pc),A1
	move.l	A0,D0
	add.l	D0,(A1)
	lea		bufor3(pc),A1
	move.l	A0,D0
	add.l	D0,(A1)
	lea		bufor4(pc),A1
	move.l	A0,D0
	add.l	D0,(A1)



	lea		$ffff8922.w,A0		; set microwire data
	lea		$ffff8924.w,A1		; set microwire mask
	move.w	#$4E2,D0			; -12db master volume	%10011100010
	move.w	#$7FF,D1			; mask	%11111111111


	REPT	4
		nop
	ENDR


	move.w	#ILOSC_TESTOW-1,D7
CPU_DATA
		lea		bufor1(PC),A2
		move.l	(A2),A2
		move.w	D1,(A1)			; set microwire mask
		move.w	D0,(A0)			; set microwire data

		REPT	ILOSC_SLOW
			move.w	(A0),(A2)+	; track microwire data
		ENDR

		REPT	ILOSC_NOP
			nop
		ENDR

		lea		bufor1(PC),A2
		add.l	#ILOSC_SLOW*2/ILOSC_TESTOW,(A2)
	dbra.w	D7,CPU_DATA



	move.w	#ILOSC_TESTOW-1,D7
CPU_MASK
		lea		bufor2(PC),A2
		move.l	(A2),A2
		move.w	D1,(A1)			; set microwire mask
		move.w	D0,(A0)			; set microwire data

		REPT	ILOSC_SLOW
			move.w	(A1),(A2)+	; track microwire mask
		ENDR

		REPT	ILOSC_NOP
			nop
		ENDR

		lea		bufor2(PC),A2
		add.l	#ILOSC_SLOW*2/ILOSC_TESTOW,(A2)
	dbra.w	D7,CPU_MASK


	move.w	#ILOSC_TESTOW-1,D7
BLITTER_DATA
		move.w	#ILOSC_SLOW,$ffff8a38.w	;init blitter ILOSC_SLOW
		move.l	A0,$ffff8a24.w		; source address
		lea		bufor3(PC),A2		; destination address
		move.l	(A2),A2
		move.l	A2,$ffff8a32.w		; destination address
		move.w	D1,(A1)				; set microwire mask
		move.w	D0,(A0)				; set microwire data
		move.b	D2,(A4)				; start track microwire data
		nop

		REPT	ILOSC_NOP
			nop
		ENDR

		lea		bufor3(PC),A2
		add.l	#ILOSC_SLOW*2/ILOSC_TESTOW,(A2)
	dbra.w	D7,BLITTER_DATA


	move.w	#ILOSC_TESTOW-1,D7
BLITTER_MASK
		move.w	#ILOSC_SLOW,$ffff8a38.w	;init blitter ILOSC_SLOW
		move.l	A1,$ffff8a24.w		; source address
		lea		bufor4(PC),A2		; destination address
		move.l	(A2),A2
		move.l	A2,$ffff8a32.w		; destination address
		move.w	D1,(A1)				; set microwire mask
		move.w	D0,(A0)				; set microwire data
		move.b	D2,(A4)				; start track microwire mask
		nop

		REPT	ILOSC_NOP
			nop
		ENDR

		lea		bufor4(PC),A2
		add.l	#ILOSC_SLOW*2/ILOSC_TESTOW,(A2)
	dbra.w	D7,BLITTER_MASK


	lea		old_sr(pc),A0
	move.w	(A0),sr


;Fopen
;	move.w	#1,-(A7)
;	move.l	A1,-(A7)
;	move.w	#$3d,-(A7)
;	trap	#1
;	addq.l	#8,A7
;	move.w	d0,uchwyt

;Fcreate
	move.w	#0,-(A7)
	pea		plik(pc)
	move.w	#$3c,-(A7)
	trap	#1
	addq.l	#8,A7
	lea		uchwyt(PC),A0
	move.w	d0,(A0)

;Fwrite
	pea		bufor(pc)
	move.l	#ILOSC_SLOW*2*4,-(A7)
	lea		uchwyt(PC),A0
	move.w	(a0),-(A7)
	move.w	#$40,-(A7)
	trap	#1
	lea	12(A7),A7

;Fclose
	lea		uchwyt(PC),A0
	move.w	(a0),-(A7)
	move.w	#$3e,-(A7)
	trap	#1
	addq.l	#4,A7

;klawisz
	;move.w	#1,-(A7)
	;trap		#1
	;addq.l		#2,A7

;koniec
	clr.w	-(A7)
	trap	#1


plik
	dc.b	'c:\result.bin',0

	EVEN
uchwyt
	dc.w	0

old_sr
	dc.w	0

bufor1
	dc.l	ILOSC_SLOW*2*0
bufor2
	dc.l	ILOSC_SLOW*2*1
bufor3
	dc.l	ILOSC_SLOW*2*2
bufor4
	dc.l	ILOSC_SLOW*2*3

bufor
	dcb.w	ILOSC_SLOW,0
	dcb.w	ILOSC_SLOW,0
	dcb.w	ILOSC_SLOW,0
	dcb.w	ILOSC_SLOW,0

